; =====
; Firefox PowerPack in NSIS
; =====
; Written by HobbyScripter
; EMAIL: HobbyScripter<hobbyscripter+fx@gmail.com>
; Blog: http://hobbyscripter.blogspot.com/
; =====


; =====
; [JHeaders
; =====
!include "MUI.nsh"
!include "FileFunc.nsh"
  !insertmacro GetFileName
!include "WordFunc.nsh"
  !insertmacro WordReplace



; =====
; 򥻳]w
; =====
Name "Firefox PowerPack HS Make" ;Name and file
OutFile "..\make.exe" ; Name of the Outputfile
BrandingText "Firefox PowerPack HS Make"
Caption "Firefox PowerPack HS Make"
ShowInstDetails show


; =====
; ʸɮ
; =====
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS
; ]w
ReserveFile "IncludeFiles\WelcomeLicense.ini"
ReserveFile "IncludeFiles\FxSettingIO.ini"
ReserveFile "IncludeFiles\XPIImport.ini"
ReserveFile "IncludeFiles\DependConfig.ini"
ReserveFile "IncludeFiles\ThemeJARImport.ini"
ReserveFile "IncludeFiles\SPImport.ini"
ReserveFile "IncludeFiles\BookmarkImport.ini"


; =====
; MUI ]w
; =====
!define MUI_ABORTWARNING ; }"}eT{"; close only when developing
!define MUI_ABORTWARNING_TEXT "w˵{|s@AzTwn}ܡH" ; close only when developing
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\modern-install-blue-full.ico" ; ]wϥ
!define MUI_WELCOMEFINISHPAGE_BITMAP "IncludeFiles\firefox-right.bmp" ; w虜ϥܳ]w
!define MUI_WELCOMEPAGE_TITLE "wϥ Firefox PowerPack HS Make"
!define MUI_WELCOMEPAGE_TEXT "wϥ Firefox PowerPack HS MakeAoӺFN޾ɱzs@ Firefox PowerPack HS AzPs@ݩz Firefox PowerPack HS C\r\n\r\nЪ`NGz NSIS nO 2.08 HWA~iH`sĶC\r\n\r\n@̡GHobbyScripter\r\nEmailGhobbyscripter+fx@gmail.com\r\nBlogGhttp://hobbyscripter.blogspot.com/" ; Welcome ]w
!insertmacro MUI_PAGE_Welcome ; Welcome ]w
!insertmacro MUI_PAGE_LICENSE "IncludeFiles\HSPL.txt" ; HSPL ϥαv
Page custom WelcomeLicensePage WelcomeLicenseCheck ; Firefox ۭq
Page custom FxSettingPage FxCheck ; Firefox ۭq
Page custom XPISettingPage XPIFunction ; Firefox ۭq
Page custom DependConfigSettingPage DependConfigFunction ; Firefox ۭq
Page custom ThemeJARSettingPage ThemeJARFunction ; Firefox ۭq
Page custom SPSettingPage SPFunction ; Firefox ۭq
Page custom BookmarksSettingPage BookmarksCheck ; Firefox ۭq
;!define MUI_FINISHPAGE_NOAUTOCLOSE ; open only when developing
!insertmacro MUI_PAGE_INSTFILES ; wˤ]w
!insertmacro MUI_PAGE_FINISH ; ɭ]w
!insertmacro MUI_LANGUAGE "TradChinese" ; ]wyAЩb̫


; =====
; {Ƴ]w
; =====
VIProductVersion "0.1.0.0"
VIAddVersionKey "ProductName" "Firefox PowerPack HS Make"
VIAddVersionKey "Comments" "@ӯzֳts@ Firefox PowerPack HS {C"
VIAddVersionKey "CompanyName" "HobbyScripter"
VIAddVersionKey "LegalCopyright" "HSPL"
VIAddVersionKey "FileDescription" "@ӯzֳts@ Firefox PowerPack HS {C"
VIAddVersionKey "FileVersion" "0.1.0.0"
VIAddVersionKey "OriginalFilename"  "make.exe"


; =====
; qܼƫŧi
; =====
Var "NSISDirPath" ; NSIS m
Var "HWND" ;  Install Option wˤ
Var "FxSetupPath" ; xs Firefox w˵{m
Var "BookmarksHTMLPath" ; xsҦm
Var "SelectedXPITempRecord" ; Ȧs XPI W
Var "09.XPI.nsh"
Var "10.ThemeJAR.nsh"
Var "11.SP.nsh"
Var "14.XPIonSelected.nsh"
Var "15.WriteSectionNumIndex.nsh"
Var "16.Desc.nsh"
Var "WelcomeWords.nsh"
Var "License.txt"
Var "SectionIndexCount" ; Section Index pMܼ


; =====
; w˵{s@
; =====
Section ""
  Call CreateNeededDir ; إ߸Ƨ
  Call ReserveIncludedSources ; ٭쥲nɮ
  Call CopySetupFiles ; ƻsnw˪ɮ
  Call WriteLicensePage ; s@v
  Call MakeSectionIndex ; إ߰ߤ@ Section Index
  Call SectionInfoCreator ; إ SectionInfo.ini
  Call FilesInitialer ; }ɮסAügJY
  Call SectionCreator ; إ߮ҥH~Ҧ Section
  Call FilesEnder ; ɮ

  ; ǳƽsĶ
  MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zn{bNsĶ{XܡH" IDYES +3
    MessageBOX MB_OK|MB_ICONINFORMATION|MB_TOPMOST|MB_SETFOREGROUND "ziHۦsĶlXAnsĶɮ׬$\"$EXEDir\Source\fxppHS.nsi$\""
    Goto EndOfMake
  MessageBOX MB_OK|MB_ICONINFORMATION|MB_TOPMOST|MB_SETFOREGROUND "sĶComplierYNQAYbsĶBɡAzU Test Installer sAˬdsĶAݦL Abort AAץC"
  ExecWait '"$NSISDirPath\makensisw.exe" "$EXEDir\Source\fxppHS.nsi"'

  ; 
  EndOfMake:
SectionEnd

Function CreateNeededDir
  CreateDirectory  "$EXEDir\Source"
  CreateDirectory  "$EXEDir\Source\IncludeFiles"
  CreateDirectory  "$EXEDir\Source\NSH"
  CreateDirectory  "$EXEDir\Source\PowerPack"
  CreateDirectory  "$EXEDir\Source\PowerPack\Setup"
  CreateDirectory  "$EXEDir\Source\PowerPack\XPI"
  CreateDirectory  "$EXEDir\Source\PowerPack\ThemeJAR"
  CreateDirectory  "$EXEDir\Source\PowerPack\SP"
FunctionEnd

Function ReserveIncludedSources
  SetOutPath "$EXEDir\Source\IncludeFiles"
  File "IncludeSources\IncludeFiles\firefox-right-original.bmp"
  File "IncludeSources\IncludeFiles\FxSettingIO.ini"
  File "IncludeSources\IncludeFiles\firefox-right.bmp"
  File "IncludeSources\IncludeFiles\firefox-right-ce.bmp"
  File "IncludeSources\IncludeFiles\InstallAll.js"
  File "IncludeSources\IncludeFiles\install.html"

  ; HUѱOSn٭쪺ɮ
  SetOutPath "$EXEDir\Source\NSH"
  File "IncludeSources\NSH\01.copyright.nsh"
  File "IncludeSources\NSH\02.headers.nsh"
  File "IncludeSources\NSH\03.basic.nsh"
  File "IncludeSources\NSH\04.fileReserving.nsh"
  File "IncludeSources\NSH\05.muiConfig.nsh"
  File "IncludeSources\NSH\06.VIKey.nsh"
  File "IncludeSources\NSH\07.var.nsh"
  File "IncludeSources\NSH\08.component.nsh"
  ;File "IncludeSources\NSH\09.XPI.nsh"
  ;File "IncludeSources\NSH\10.ThemeJAR.nsh"
  ;File "IncludeSources\NSH\11.SP.nsh"
  File "IncludeSources\NSH\12.bookmarks.nsh"
  File "IncludeSources\NSH\13.createHTML.nsh"
  ;File "IncludeSources\NSH\14.XPIonSelected.nsh"
  ;File "IncludeSources\NSH\15.WriteSectionNumIndex.nsh"
  ;File "IncludeSources\NSH\16.Desc.nsh"
  File "IncludeSources\NSH\17.End.nsh"
  ;File "IncludeSources\NSH\WelcomeWords.nsh"
  
  SetOutPath "$EXEDir\Source"
  File "IncludeSources\fxppHS.nsi"
FunctionEnd

Function CopySetupFiles
  ; ƻs Firefox w˵{
  ReadINIStr $FxSetupPath "$PLUGINSDIR\FxSettingIO.ini" "Field 3" "State"
  CopyFiles /SILENT $FxSetupPath "$EXEDir\Source\PowerPack\Setup"
  ${GetFileName} "$FxSetupPath" $R1
  Rename "$EXEDir\Source\PowerPack\Setup\$R1" "$EXEDir\Source\PowerPack\Setup\Setup.exe"

  ; ƻsM
  ReadINIStr $R1 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  CopyXPIDoLoop:
    IntCmp $R1 0 CopyXPIDoLoopEnd CopyXPIDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "x$R2" "FilePath"
    CopyFiles $R3 "$EXEDir\Source\PowerPack\XPI"
    IntOp $R1 $R1 - 1
    Goto CopyXPIDoLoop
  CopyXPIDoLoopEnd:

  ; ƻsGDD
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  CopyThemeJARDoLoop:
    IntCmp $R1 0 CopyThemeJARDoLoopEnd CopyThemeJARDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\ThemeJARlist.ini" "x$R2" "FilePath"
    CopyFiles $R3 "$EXEDir\Source\PowerPack\ThemeJAR"
    IntOp $R1 $R1 - 1
    Goto CopyThemeJARDoLoop
  CopyThemeJARDoLoopEnd:

  ; ƻsjM
  ReadINIStr $R1 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  CopySPDoLoop:
    IntCmp $R1 0 CopySPDoLoopEnd CopySPDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\SPlist.ini" "SP" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\SPlist.ini" "x$R2" "FileSRCPath"
    ReadINIStr $R4 "$PLUGINSDIR\SPlist.ini" "x$R2" "FileICONPath"
    CopyFiles $R3 "$EXEDir\Source\PowerPack\SP"
    CopyFiles $R4 "$EXEDir\Source\PowerPack\SP"
    IntOp $R1 $R1 - 1
    Goto CopySPDoLoop
  CopySPDoLoopEnd:

  ; ƻs bookmarks.html
  ReadINIStr $BookmarksHTMLPath "$PLUGINSDIR\BookmarkImport.ini" "Field 4" "State"
  CopyFiles /SILENT $BookmarksHTMLPath "$EXEDir\Source\PowerPack"
  ${GetFileName} "$FxSetupPath" $R1
  Rename "$EXEDir\Source\PowerPack\$R1" "$EXEDir\Source\PowerPack\bookmarks.html"
FunctionEnd

Function WriteLicensePage
  ReadINIStr $R2 "$PLUGINSDIR\WelcomeLicense.ini" "Field 9" "State" ; W
  ReadINIStr $R3 "$PLUGINSDIR\WelcomeLicense.ini" "Field 10" "State" ; Email
  ReadINIStr $R4 "$PLUGINSDIR\WelcomeLicense.ini" "Field 11" "State" ; 
  ReadINIStr $R5 "$PLUGINSDIR\WelcomeLicense.ini" "Field 12" "State" ; v
  ${WordReplace} $R5 "\r\n" "$\r$\n" "+" $R5 ; Ÿ
  
  FileOpen $License.txt "$EXEDir\Source\IncludeFiles\License.txt" w
  StrCmp $R5 "" +2 0
    FileWrite $License.txt "$R5$\r$\n$\r$\n"
  StrCmp $R2 "" +2 0
    FileWrite $License.txt "$R2$\r$\n"
  StrCmp $R3 "" +2 0
    FileWrite $License.txt "Email: $R3$\r$\n"
  StrCmp $R4 "" +2 0
    FileWrite $License.txt ": $R4$\r$\n"

  FileWrite $License.txt "$\r$\n----------ju----------$\r$\n$\r$\n"
  FileWrite $License.txt "w˵{tҪMBw˶ءO HobbyScript s@Bîھ HobbyScripter Public License oA{aOҡAϥΫezۦO_nϥΡA@JDAzߤ@వƬO^ҹJ쪺DC$\r$\n$\r$\n"
  FileWrite $License.txt "ƵGҪMBw˶تvݩw˵{ʸ˪̡BκW@̩Ҿ֦AP HobbyScripter @LYAҪMBw˶تϥαvЬs@HC$\r$\n$\r$\n"
  FileWrite $License.txt "HobbyScripter$\r$\n"
  FileWrite $License.txt "Email: hobbyscripter+fx@gmail.com$\r$\n"
  FileWrite $License.txt "Blog: http://hobbyscripter.blogspot.com$\r$\n"
FunctionEnd

Function MakeSectionIndex
  ; l SectionIndex
  IntOp $SectionIndexCount 0 + 1

    ; gMSectionIndex
  ReadINIStr $R1 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  WriteXPISIDoLoop: ; WriteXPISI = WriteXPISectionIndex
    IntCmp $R1 0 WriteXPISIDoLoopEnd WriteXPISIDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R1"
    WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$R2" "SectionIndex" "Sec$SectionIndexCount"
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto WriteXPISIDoLoop
  WriteXPISIDoLoopEnd:

  ; gGDDSectionIndex
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  WriteThemeJARSIDoLoop: ; SI = SectionIndex
    IntCmp $R1 0 WriteThemeJARSIDoLoopEnd WriteThemeJARSIDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R1"
    WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "x$R2" "SectionIndex" "Sec$SectionIndexCount"
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto WriteThemeJARSIDoLoop
  WriteThemeJARSIDoLoopEnd:

  ; gjMSectionIndex
  ReadINIStr $R1 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  WriteSPSIDoLoop:
    IntCmp $R1 0 WriteSPSIDoLoopEnd WriteSPSIDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\SPlist.ini" "SP" "File$R1"
    WriteINIStr "$PLUGINSDIR\SPlist.ini" "x$R2" "SectionIndex" "Sec$SectionIndexCount"
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto WriteSPSIDoLoop
  WriteSPSIDoLoopEnd:
FunctionEnd

Function SectionInfoCreator
  ; gY
  WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "Basic" "SectionNumIndexIsFilled" 0

  ; gMSectionInfo
  ReadINIStr $R1 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  CreateXPIInfoDoLoop:
    IntCmp $R1 0 CreateXPIInfoDoLoopEnd CreateXPIInfoDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "x$R2" "DependCount"
    ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "x$R2" "ConflictCount"
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "Selected" 0
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "SectionNumIndex" ""
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "DependCount" $R3
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "ConflictCount" $R4
    CreateXPIDependDoLoop:
      IntCmp $R3 0 CreateXPIDependDoLoopEnd CreateXPIDependDoLoopEnd 0
      ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R2" "Depend$R3"
      WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "Depend$R3" $R5
      IntOp $R3 $R3 - 1
      Goto CreateXPIDependDoLoop
    CreateXPIDependDoLoopEnd:
    CreateXPIConflictDoLoop:
      IntCmp $R4 0 CreateXPIConflictDoLoopEnd CreateXPIConflictDoLoopEnd 0
      ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R2" "Conflict$R4"
      WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "Conflict$R4" $R5
      IntOp $R4 $R4 - 1
      Goto CreateXPIConflictDoLoop
    CreateXPIConflictDoLoopEnd:
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto CreateXPIInfoDoLoop
  CreateXPIInfoDoLoopEnd:

  ; gGDDSectionInfo
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  CreateThemeJARInfoDoLoop:
    IntCmp $R1 0 CreateThemeJARInfoDoLoopEnd CreateThemeJARInfoDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R1"
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "Selected" 0
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "SectionNumIndex" ""
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "DependCount" 0
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "ConflictCount" 0
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto CreateThemeJARInfoDoLoop
  CreateThemeJARInfoDoLoopEnd:

  ; gjMSectionInfo
  ReadINIStr $R1 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  CreateSPInfoDoLoop:
    IntCmp $R1 0 CreateSPInfoDoLoopEnd CreateSPInfoDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\SPlist.ini" "SP" "File$R1"
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "Selected" 0
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "SectionNumIndex" ""
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "DependCount" 0
    WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x$R2" "ConflictCount" 0
    IntOp $SectionIndexCount $SectionIndexCount + 1
    IntOp $R1 $R1 - 1
    Goto CreateSPInfoDoLoop
  CreateSPInfoDoLoopEnd:
  
  ; gҪSectionInfo
  WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x" "Selected" 0
  WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x" "SectionNumIndex" ""
  WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x" "DependCount" 0
  WriteINIStr "$EXEDir\Source\IncludeFiles\SectionInfo.ini" "x" "ConflictCount" 0
FunctionEnd

Function FilesInitialer
  FileOpen $09.XPI.nsh "$EXEDir\Source\NSH\09.XPI.nsh" w
  FileOpen $10.ThemeJAR.nsh "$EXEDir\Source\NSH\10.ThemeJAR.nsh" w
  FileOpen $11.SP.nsh "$EXEDir\Source\NSH\11.SP.nsh" w
  FileOpen $14.XPIonSelected.nsh "$EXEDir\Source\NSH\14.XPIonSelected.nsh" w
  FileOpen $15.WriteSectionNumIndex.nsh "$EXEDir\Source\NSH\15.WriteSectionNumIndex.nsh" w
  FileOpen $16.Desc.nsh "$EXEDir\Source\NSH\16.Desc.nsh" w
  FileOpen $WelcomeWords.nsh "$EXEDir\Source\NSH\WelcomeWords.nsh" w
  
  ; [Jɮ׼Y
  ; 09.XPI.nsh
  FileWrite $09.XPI.nsh "; =====$\r$\n"
  FileWrite $09.XPI.nsh "; w˿϶$\r$\n"
  FileWrite $09.XPI.nsh "; =====$\r$\n"
  FileWrite $09.XPI.nsh "; XRMs$\r$\n"
  FileWrite $09.XPI.nsh "SectionGroup /e $\"!XRM$\" $\"secGXPI$\"$\r$\n"
  
  ; 10.ThemeJAR.nsh
  FileWrite $10.ThemeJAR.nsh "; GDDs$\r$\n"
  FileWrite $10.ThemeJAR.nsh "SectionGroup $\"!GDD$\" $\"secGThemeJAR$\"$\r$\n"
  
  ; 11.SP.nsh
  FileWrite $11.SP.nsh "; jMs$\r$\n"
  FileWrite $11.SP.nsh "SectionGroup $\"!jM$\" $\"secGSP$\"$\r$\n"
  
  ; 14.XPIonSelected.nsh
  FileWrite $14.XPIonSelected.nsh "; ϥΪ̿ɷ|̩ۨˬd禡$\r$\n"
  FileWrite $14.XPIonSelected.nsh "Function .onSelChange$\r$\n"
  FileWrite $14.XPIonSelected.nsh "  ; N SectionNumIndex gJ SectionInfo.ini$\r$\n"
  FileWrite $14.XPIonSelected.nsh "  ReadINIStr $$R9 $\"$$PLUGINSDIR\SectionInfo.ini$\" $\"Basic$\" $\"SectionNumIndexIsFilled$\"$\r$\n"
  FileWrite $14.XPIonSelected.nsh "  StrCmp $$R9 $\"0$\" 0 +2$\r$\n"
  FileWrite $14.XPIonSelected.nsh "  Call WriteSectionNumIndex$\r$\n"
  
  ; 15.WriteSectionNumIndex.nsh
  FileWrite $15.WriteSectionNumIndex.nsh "; ΨӱN SectionNumIndex gJ SectionInfo.ini 禡$\r$\n"
  FileWrite $15.WriteSectionNumIndex.nsh "Function WriteSectionNumIndex$\r$\n"
  FileWrite $15.WriteSectionNumIndex.nsh "  WriteINIStr $\"$PLUGINSDIR\SectionInfo.ini$\" $\"Basic$\" $\"SectionNumIndexIsFilled$\" $\"1$\"$\r$\n"
  
  ; 16.Desc.nsh
  FileWrite $16.Desc.nsh "; =====$\r$\n"
  FileWrite $16.Desc.nsh "; w˿ﶵ$\r$\n"
  FileWrite $16.Desc.nsh "; =====$\r$\n"
  FileWrite $16.Desc.nsh "; oǥΨӱNgJuyz(Description)v줤{X$\r$\n"
  FileWrite $16.Desc.nsh "!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN$\r$\n"
  FileWrite $16.Desc.nsh "  ; !insertmacro MUI_DESCRIPTION_TEXT $${Ϭq} $\"$\"$\r$\n"

  ; WelcomeWords.nsh
  ReadINIStr $R1 "$PLUGINSDIR\WelcomeLicense.ini" "Field 8" "State" ; w
  StrCmp $R1 "" +2 0
    FileWrite $WelcomeWords.nsh "!define MUI_WELCOMEPAGE_TEXT $\"$R1$\"$\r$\n"
FunctionEnd

Function SectionCreator
  ; g XPI  Section
  ReadINIStr $R1 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  WriteXPISecDoLoop:
    IntCmp $R1 0 WriteXPISecDoLoopEnd WriteXPISecDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "x$R2" "FilePath"
    ${GetFileName} "$R3" $R4 ; Todo: ${GetFileName} "$R3" $R3
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R2" "SectionIndex"
    ReadINIStr $R6 "$PLUGINSDIR\XPIlist.ini" "x$R2" "Desc"

    FileWrite $09.XPI.nsh "  !insertmacro InstallXPI $\"$R2$\" $\"$R5$\" $\"$R4$\"$\r$\n"
    FileWrite $14.XPIonSelected.nsh "  !insertmacro CheckDependConflict $\"$${$R5}$\" $\"$R2$\"$\r$\n"
    FileWrite $15.WriteSectionNumIndex.nsh "  WriteINIStr $\"$$PLUGINSDIR\SectionInfo.ini$\" $\"x$R2$\" $\"SectionNumIndex$\" $\"$${$R5}$\"$\r$\n"
    FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${$R5} $\"$R6$\"$\r$\n"

    IntOp $R1 $R1 - 1
    Goto WriteXPISecDoLoop
  WriteXPISecDoLoopEnd:

  ; ƻsGDD
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  WriteThemeJARSecDoLoop:
    IntCmp $R1 0 WriteThemeJARSecDoLoopEnd WriteThemeJARSecDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\ThemeJARlist.ini" "x$R2" "FilePath"
    ${GetFileName} "$R3" $R4 ; Todo: ${GetFileName} "$R3" $R3
    ReadINIStr $R5 "$PLUGINSDIR\ThemeJARlist.ini" "x$R2" "SectionIndex"
    ReadINIStr $R6 "$PLUGINSDIR\ThemeJARlist.ini" "x$R2" "Desc"

    FileWrite $10.ThemeJAR.nsh "  !insertmacro InstallTheme $\"$R2$\" $\"$R5$\" $\"$R4$\"$\r$\n"
    FileWrite $14.XPIonSelected.nsh "  !insertmacro CheckDependConflict $\"$${$R5}$\" $\"$R2$\"$\r$\n"
    FileWrite $15.WriteSectionNumIndex.nsh "  WriteINIStr $\"$$PLUGINSDIR\SectionInfo.ini$\" $\"x$R2$\" $\"SectionNumIndex$\" $\"$${$R5}$\"$\r$\n"
    FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${$R5} $\"$R6$\"$\r$\n"

    IntOp $R1 $R1 - 1
    Goto WriteThemeJARSecDoLoop
  WriteThemeJARSecDoLoopEnd:

  ; ƻsjM
  ReadINIStr $R1 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  WriteSPSecDoLoop:
    IntCmp $R1 0 WriteSPSecDoLoopEnd WriteSPSecDoLoopEnd 0
    ReadINIStr $R2 "$PLUGINSDIR\SPlist.ini" "SP" "File$R1"
    ReadINIStr $R3 "$PLUGINSDIR\SPlist.ini" "x$R2" "FileSRCPath"
    ${GetFileName} "$R3" $R3
    ReadINIStr $R4 "$PLUGINSDIR\SPlist.ini" "x$R2" "FileICONPath"
    ${GetFileName} "$R4" $R4
    ReadINIStr $R5 "$PLUGINSDIR\SPlist.ini" "x$R2" "SectionIndex"
    ReadINIStr $R6 "$PLUGINSDIR\SPlist.ini" "x$R2" "Desc"

    FileWrite $11.SP.nsh "  !insertmacro InstallSP $\"$R2$\" $\"$R5$\" $\"$R3$\" $\"$R4$\"$\r$\n"
    FileWrite $14.XPIonSelected.nsh "  !insertmacro CheckDependConflict $\"$${$R5}$\" $\"$R2$\"$\r$\n"
    FileWrite $15.WriteSectionNumIndex.nsh "  WriteINIStr $\"$$PLUGINSDIR\SectionInfo.ini$\" $\"x$R2$\" $\"SectionNumIndex$\" $\"$${$R5}$\"$\r$\n"
    FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${$R5} $\"$R6$\"$\r$\n"
    IntOp $R1 $R1 - 1
    Goto WriteSPSecDoLoop
  WriteSPSecDoLoopEnd:
FunctionEnd

Function FilesEnder
  FileWrite $09.XPI.nsh "SectionGroupEnd"

  FileWrite $10.ThemeJAR.nsh "SectionGroupEnd"

  FileWrite $11.SP.nsh "SectionGroupEnd"

  FileWrite $14.XPIonSelected.nsh "!insertmacro CheckDependConflict $\"$${secBookmarks}$\" $\"$\"$\r$\n"
  FileWrite $14.XPIonSelected.nsh "FunctionEnd"

  FileWrite $15.WriteSectionNumIndex.nsh "WriteINIStr $\"$PLUGINSDIR\SectionInfo.ini$\" $\"x$\" $\"SectionNumIndex$\" $\"$${secBookmarks}$\"$\r$\n"
  FileWrite $15.WriteSectionNumIndex.nsh "FunctionEnd"

  FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${secBookmarks} $\"PowerPack s@̰ҡC$\"$\r$\n"
  FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${secGXPI} $\"boӤziHXRMC$\"$\r$\n"
  FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${secGThemeJAR} $\"boӤziHGDDC$\"$\r$\n"
  FileWrite $16.Desc.nsh "  !insertmacro MUI_DESCRIPTION_TEXT $${secGSP} $\"boӤziHjM PluginC$\"$\r$\n"
  FileWrite $16.Desc.nsh "  !insertmacro MUI_FUNCTION_DESCRIPTION_END"

  FileClose $09.XPI.nsh
  FileClose $10.ThemeJAR.nsh
  FileClose $11.SP.nsh
  FileClose $14.XPIonSelected.nsh
  FileClose $15.WriteSectionNumIndex.nsh
  FileClose $16.Desc.nsh
  FileClose $WelcomeWords.nsh
FunctionEnd



; =====
; wBv
; =====
Function WelcomeLicensePage
  !insertmacro MUI_HEADER_TEXT "wBv" "пJHU"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "WelcomeLicense.ini"
  Pop $HWND ;HWND of dialog
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function WelcomeLicenseCheck
  ReadINIStr $R1 "$PLUGINSDIR\WelcomeLicense.ini" "Field 8" "State" ; w
  ReadINIStr $R2 "$PLUGINSDIR\WelcomeLicense.ini" "Field 9" "State" ; W
  ReadINIStr $R3 "$PLUGINSDIR\WelcomeLicense.ini" "Field 10" "State" ; Email
  ReadINIStr $R4 "$PLUGINSDIR\WelcomeLicense.ini" "Field 11" "State" ; 
  ReadINIStr $R5 "$PLUGINSDIR\WelcomeLicense.ini" "Field 12" "State" ; v
  
  StrCmp $R1 "" 0 +4
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zTwngwܡH" IDYES +3
    Abort
    Goto EndOfWelcomeLicenseCheck

  StrCmp $R2 "" 0 +4
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zTwngzWٶܡH" IDYES +3
    Abort
    Goto EndOfWelcomeLicenseCheck

  StrCmp $R3 "" 0 +4
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zTwngzEmailܡH" IDYES +3
    Abort
    Goto EndOfWelcomeLicenseCheck

  StrCmp $R4 "" 0 +4
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zTwngzܡH" IDYES +3
    Abort
    Goto EndOfWelcomeLicenseCheck

  StrCmp $R5 "" 0 +4
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "zTwngvܡH" IDYES +3
    Abort
    Goto EndOfWelcomeLicenseCheck

  ; ˬd
  EndOfWelcomeLicenseCheck:
FunctionEnd

; =====
; Firefox ]w
; =====
Function FxSettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox w˵{]w" "п Firefox w˵{m"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "FxSettingIO.ini"
  Pop $HWND ;HWND of dialog

  GetDlgItem $0 $HWND 1202 ; w"ɮs"r
  EnableWindow $0 0

  ReadINIStr $FxSetupPath "$PLUGINSDIR\FxSettingIO.ini" "Field 3" "State" ; Ū
  IfFileExists $FxSetupPath +3 0 ; YɮצsbAhLw
    GetDlgItem $0 $HWNDPARENT 1 ; w"U@B"s
    EnableWindow $0 0

  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function FxCheck
  ReadINIStr $1 "$PLUGINSDIR\FxSettingIO.ini" "Settings" "State"
  StrCmp $1 "3" CheckField3 ; U"..."sAiˬd
  StrCmp $1 "0" EndOfFxCheck ; U"U@B"sAL

  ; ˬd Firefox w˵{|
  CheckField3:
  ReadINIStr $FxSetupPath "$PLUGINSDIR\FxSettingIO.ini" "Field 3" "State"
  IfFileExists $FxSetupPath EnableNextButton 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~{|"
    GetDlgItem $0 $HWND 1202 ; X File Request Text Field
    SendMessage $0 ${WM_SETTEXT} 1 "STR:" ; M
    GetDlgItem $0 $HWNDPARENT 1 ; X"U@B"s
    EnableWindow $0 0 ; w"U@B"s
    Abort
    Goto EndOfFxCheck
  
  ; Yɮצsb
  EnableNextButton:
  GetDlgItem $0 $HWNDPARENT 1 ; Ѱw"U@B"s
  EnableWindow $0 1
  Abort
  
  ; ˬd
  EndOfFxCheck:
FunctionEnd

; =====
; XPI ]wפJ
; =====
Function XPISettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox PowerPack HS XPI MﶵפJ" "жפJ XPI ɨüg"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "XPIImport.ini"
  Pop $HWND ;HWND of dialog
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function XPIFunction
  ReadINIStr $1 "$PLUGINSDIR\XPIImport.ini" "Settings" "State"
  StrCmp $1 "12" AddXPIFunc ; U"sW"s
  StrCmp $1 "3" DelXPIFunc ; U"R"s
  StrCmp $1 "0" OutputName ; U"U@B"sANƼgJ̩ۨʳ]we

  ; UsWsAsW
  AddXPIFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\XPIImport.ini" "Field 7" "State"
  ReadINIStr $R2 "$PLUGINSDIR\XPIImport.ini" "Field 8" "State"
  ReadINIStr $R3 "$PLUGINSDIR\XPIImport.ini" "Field 10" "State"
  ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "x$R1" "Desc"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJMW"
    Abort
    Goto EndOfXPIFunction
  StrCmp $R2 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJM󻡩"
    Abort
    Goto EndOfXPIFunction
  StrCmp $R3 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ɮ׸|"
    Abort
    Goto EndOfXPIFunction
  IfFileExists $R3 +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ɮ׸|"
    Abort
    Goto EndOfXPIFunction
  StrCmp $R4 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١C"
    Abort
    Goto EndOfXPIFunction
  ; T{L~AJ
  ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  IntOP $R5 $R5 + 1
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "XPI" "Count" $R5
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R5" "$R1"
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$R1" "Desc" "$R2"
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$R1" "FilePath" "$R3"
  ; NW٥[JkRC
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  ; MſJ
  GetDlgItem $0 $HWND 1206
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1207
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1209
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  Abort
  Goto EndOfXPIFunction

  ; U"R"s
  DelXPIFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\XPIImport.ini" "Field 2" "State"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܭnRﶵ"
    Abort
    Goto EndOfXPIFunction
  ; iƧR
  ; MԲӸT
  DeleteINISec "$PLUGINSDIR\XPIlist.ini" "x$R1"
  ; MW٬
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  IntOp $R2 $R2 + 0 ; jഫƦr
  IntOp $R3 0 + 1
  IntOp $R4 0 + 1
  DelNameDoLoop:
    IntCmp $R2 $R3 0 DelNameDoLoopEnd 0 ; if($R2==$R3||$R2>$R3){goto 0;}else{Goto DelNameDoLoopEnd;}
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R3"
    StrCmp $R1 $R5 +3 0 ; W٭Y@ˡAxs
      WriteINIStr "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R4" $R5
      IntOp $R4 $R4 + 1
    IntOp $R3 $R3 + 1
    Goto DelNameDoLoop
  DelNameDoLoopEnd:
  DeleteINIStr "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R2"
  IntOp $R6 $R2 - 1 ; ouƥ
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "XPI" "Count" "$R6"
  ; M椤W
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_FINDSTRINGEXACT} 1 "STR:$R1" $2
  SendMessage $0 ${LB_DELETESTRING} $2 1
  Abort
  Goto EndOfXPIFunction
  
  ; U"U@B"sANƼgJ̩ۨʳ]weAHΥ
  OutputName:
  ReadINIStr $R1 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  StrCpy $R2 ""
  OutputNameDoLoop:
    IntCmp $R1 0 OutputNameDoLoopEnd OutputNameDoLoopEnd 0
    ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R1"
    StrCpy $R2 "$R2|$R3"
    IntOP $R1 $R1 - 1
    Goto OutputNameDoLoop
  OutputNameDoLoopEnd:
  StrCpy $R2 $R2 "" 1
  WriteINIStr "$PLUGINSDIR\XPIImport.ini" "Field 2" "ListItems" $R2
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 3" "ListItems" $R2
  
  ; 禡
  EndOfXPIFunction:
FunctionEnd


; =====
; XPI ]wp
; =====
Function DependConfigSettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox PowerPack HS XPI Mﶵp" "жפJ XPI ɨüg"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "DependConfig.ini"
  Pop $HWND ;HWND of dialog
  
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 3" "State" ""
  GetDlgItem $0 $HWND 1214 ; w"MW"
  EnableWindow $0 0
  GetDlgItem $0 $HWND 1213 ; w"MW"
  EnableWindow $0 0
  GetDlgItem $0 $HWND 1211 ; w"MW"
  EnableWindow $0 0
  GetDlgItem $0 $HWND 1212 ; w"MW"
  EnableWindow $0 0
  GetDlgItem $0 $HWND 1210 ; w"MW"
  EnableWindow $0 0
  
  
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function DependConfigFunction
  ReadINIStr $1 "$PLUGINSDIR\DependConfig.ini" "Settings" "State"
  StrCmp $1 "3" ChangeXPI ; U"MM"
  StrCmp $1 "14" AddDependFunc ; U̩ۨ">"s
  StrCmp $1 "12" DelDependFunc ; U̩ۨ"<"s
  StrCmp $1 "13" AddConflictFunc ; U۽ĩ">"s
  StrCmp $1 "11" DelConflictFunc ; U۽ĩ"<"s
  StrCmp $1 "0" EndOfDependConfigFunction ; U"U@B"s

  ; U"MM"
  ChangeXPI:
  ; Ū
  ReadINIStr $R1 "$PLUGINSDIR\DependConfig.ini" "Field 3" "State"
  GetDlgItem $0 $HWND 1214 ; ܿM
  SendMessage $0 ${WM_SETTEXT} 1 "STR:$R1"
  Call RefreshDCLB ; sz̩ۨʡB۽ĩʿ
  StrCpy $SelectedXPITempRecord $R1 ; ȦsW
  GetDlgItem $0 $HWND 1213 ; w"MW"
  EnableWindow $0 1
  GetDlgItem $0 $HWND 1211 ; w"MW"
  EnableWindow $0 1
  GetDlgItem $0 $HWND 1212 ; w"MW"
  EnableWindow $0 1
  GetDlgItem $0 $HWND 1210 ; w"MW"
  EnableWindow $0 1
  Abort
  Goto EndOfDependConfigFunction

  ; U̩ۨ">"s
  AddDependFunc:
  ReadINIStr $R1 "$PLUGINSDIR\DependConfig.ini" "Field 9" "State" ; n̪ۨM
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܮMW"
    Abort
    Goto EndOfDependConfigFunction
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "DependCount"
  IntOp $R2 $R2 + 1
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "DependCount" $R2
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Depend$R2" $R1
  ; M LB ﶵ
  GetDlgItem $0 $HWND 1208 ; ̩ۨʡA LBARﶵ
  SendMessage $0 ${LB_FINDSTRINGEXACT} 1 "STR:$R1" $2
  SendMessage $0 ${LB_DELETESTRING} $2 1
  GetDlgItem $0 $HWND 1209 ; ̩ۨʡAk LBAsWﶵ
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  ; MſA
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 9" "State" ""
  Abort
  Goto EndOfDependConfigFunction

  ; U̩ۨ"<"s
  DelDependFunc:
  ReadINIStr $R1 "$PLUGINSDIR\DependConfig.ini" "Field 10" "State" ; n̪ۨM
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܮMW"
    Abort
    Goto EndOfDependConfigFunction
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "DependCount"
  IntOp $R3 0 + 1
  IntOp $R4 0 + 1
  DelDependDoLoop:
    IntCmp $R3 $R2 0 0 DelDependDoLoopEnd
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Depend$R3"
    StrCmp $R5 $R1 +3 0 ; YۦPAhxs
      WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Depend$R4" $R5
      IntOp $R4 $R4 + 1
    StrCmp $R5 $R1 0 +2 ; YۦPAhsUơAѧR LB 
      IntOp $2 $R4 - 1
    IntOp $R3 $R3 + 1
    Goto DelDependDoLoop
  DelDependDoLoopEnd:
  DeleteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Depend$R2"
  IntOp $R2 $R2 - 1
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "DependCount" $R2
  ; M LB ﶵ
  GetDlgItem $0 $HWND 1208 ; ̩ۨʡA LBAsWﶵ
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  GetDlgItem $9 $HWND 1209 ; ̩ۨʡAk LBARﶵ
  SendMessage $9 ${LB_DELETESTRING} $2 1 ; ϥάW

  ; MſA
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 10" "State" ""
  Abort
  Goto EndOfDependConfigFunction

  ; U۽ĩ">"s
  AddConflictFunc:
  ReadINIStr $R1 "$PLUGINSDIR\DependConfig.ini" "Field 7" "State" ; n۽ĪM
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܮMW"
    Abort
    Goto EndOfDependConfigFunction
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "ConflictCount"
  IntOp $R2 $R2 + 1
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "ConflictCount" $R2
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Conflict$R2" $R1
  ; M LB ﶵ
  GetDlgItem $0 $HWND 1206 ; ۽ĩʡA LBARﶵ
  SendMessage $0 ${LB_FINDSTRINGEXACT} 1 "STR:$R1" $2
  SendMessage $0 ${LB_DELETESTRING} $2 1
  GetDlgItem $0 $HWND 1207 ; ۽ĩʡAk LBAsWﶵ
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  ; MſA
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 7" "State" ""
  Abort
  Goto EndOfDependConfigFunction

  ; U۽ĩ"<"s
  DelConflictFunc:
  ReadINIStr $R1 "$PLUGINSDIR\DependConfig.ini" "Field 8" "State" ; n̪ۨM
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܮMW"
    Abort
    Goto EndOfDependConfigFunction
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "ConflictCount"
  IntOp $R3 0 + 1
  IntOp $R4 0 + 1
  DelConflictDoLoop:
    IntCmp $R3 $R2 0 0 DelConflictDoLoopEnd
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Conflict$R3"
    StrCmp $R5 $R1 +3 0 ; YۦPAhxs
      WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Conflict$R4" $R5
      IntOp $R4 $R4 + 1
    StrCmp $R5 $R1 0 +2 ; YۦPAhsUơAѧR LB 
      IntOp $2 $R4 - 1
    IntOp $R3 $R3 + 1
    Goto DelConflictDoLoop
  DelConflictDoLoopEnd:
  DeleteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Conflict$R2"
  IntOp $R2 $R2 - 1
  WriteINIStr "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "ConflictCount" $R2
  ; M LB ﶵ
  GetDlgItem $0 $HWND 1206 ; ۽ĩʡA LBAsWﶵ
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  GetDlgItem $0 $HWND 1207 ; ۽ĩʡAk LBARﶵ
  SendMessage $0 ${LB_DELETESTRING} $2 1
  ; MſA
  WriteINIStr "$PLUGINSDIR\DependConfig.ini" "Field 8" "State" ""
  Abort
  Goto EndOfDependConfigFunction

  ; 
  EndOfDependConfigFunction:
FunctionEnd

; 歫sz
Function RefreshDCLB
  ReadINIStr $R2 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "Desc"
  StrCmp $R2 "" AddDependLB 0 ; ˬdW@ XPI O_sbAYsbA~HU

  ; ˬd̩ۨʳ]wAM̩ۨ LB 
  ClearDependLB:
  ; o LB 
  GetDlgItem $3 $HWND 1209 ; ̩ۨʡAk LB
  GetDlgItem $4 $HWND 1208 ; ̩ۨʡA LB
  ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "DependCount"
  IntOp $R4 $R4 + 0 ; jഫ
  IntOp $R3 $R3 - $R4
  IntOp $R3 $R3 - 1 ; ] LB sOq 0 _
  ClearUnDependedLBDoLoop:
    IntCmp $R3 0 0 ClearUnDependedLBDoLoopEnd 0
    SendMessage $4 ${LB_DELETESTRING} 0 1
    IntOp $R3 $R3 - 1
    Goto ClearUnDependedLBDoLoop
  ClearUnDependedLBDoLoopEnd:
  IntOp $R4 $R4 - 1 ; ] LB sOq 0 _
  ClearDependedLBDoLoop:
    IntCmp $R4 0 0 ClearDependedLBDoLoopEnd 0
    SendMessage $3 ${LB_DELETESTRING} 0 1
    IntOp $R4 $R4 - 1
    Goto ClearDependedLBDoLoop
  ClearDependedLBDoLoopEnd:

  ; ˬd۽ĩʳ]wAM̩ۨ LB 
  ClearConflictLB:
  ; o LB 
  GetDlgItem $3 $HWND 1207 ; ۽ĩʡAk LB
  GetDlgItem $4 $HWND 1206 ; ۽ĩʡA LB
  ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "x$SelectedXPITempRecord" "ConflictCount"
  IntOp $R4 $R4 + 0 ; jഫ
  IntOp $R3 $R3 - $R4
  IntOp $R3 $R3 - 1 ; ] LB sOq 0 _
  ClearUnConflictedLBDoLoop:
    IntCmp $R3 0 0 ClearUnConflictedLBDoLoopEnd 0
    SendMessage $4 ${LB_DELETESTRING} 0 1
    IntOp $R3 $R3 - 1
    Goto ClearUnConflictedLBDoLoop
  ClearUnConflictedLBDoLoopEnd:
  IntOp $R4 $R4 - 1 ; ] LB sOq 0 _
  ClearConflictedLBDoLoop:
    IntCmp $R4 0 0 ClearConflictedLBDoLoopEnd 0
    SendMessage $3 ${LB_DELETESTRING} 0 1
    IntOp $R4 $R4 - 1
    Goto ClearConflictedLBDoLoop
  ClearConflictedLBDoLoopEnd:
  
  ; gJs̩ۨʸ
  AddDependLB:
  GetDlgItem $3 $HWND 1209 ; ̩ۨʡAk LB
  GetDlgItem $4 $HWND 1208 ; ̩ۨʡA LB
  ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  IntOp $R3 $R3 + 0 ; jഫ
  AddDependLBDoLoop:
    IntCmp $R3 0 AddDependLBDoLoopEnd AddDependLBDoLoopEnd 0
    ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R3"
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R1" "DependCount"
    IntOp $R5 $R5 + 0 ; jഫ
    StrCpy $R6 "0"
    AddDependedLBDoLoop:
      IntCmp $R5 0 AddDependedLBDoLoopEnd AddDependedLBDoLoopEnd 0
      ReadINIStr $R7 "$PLUGINSDIR\XPIlist.ini" "x$R1" "Depend$R5"
      StrCmp $R4 $R7 0 +4
        SendMessage $3 ${LB_ADDSTRING} 1 "STR:$R4"
        StrCpy $R6 "1"
        Goto AddDependedLBDoLoopEnd
      IntOp $R5 $R5 - 1
      Goto AddDependedLBDoLoop
    AddDependedLBDoLoopEnd:
    StrCmp $R6 "0" 0 +2
    SendMessage $4 ${LB_ADDSTRING} 1 "STR:$R4"
    IntOp $R3 $R3 - 1
    Goto AddDependLBDoLoop
  AddDependLBDoLoopEnd:
  
  ; gJs۽ĩʸ
  AddConflictLB:
  ; o LB 
  GetDlgItem $3 $HWND 1207 ; ۽ĩʡAk LB
  GetDlgItem $4 $HWND 1206 ; ۽ĩʡA LB
  ReadINIStr $R3 "$PLUGINSDIR\XPIlist.ini" "XPI" "Count"
  IntOp $R3 $R3 + 0 ; jഫ
  AddConflictLBDoLoop:
    IntCmp $R3 0 AddConflictLBDoLoopEnd AddConflictLBDoLoopEnd 0
    ReadINIStr $R4 "$PLUGINSDIR\XPIlist.ini" "XPI" "File$R3"
    ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R1" "ConflictCount"
    IntOp $R5 $R5 + 0 ; jഫ
    StrCpy $R6 "0"
    AddConflictedLBDoLoop:
      IntCmp $R5 0 AddConflictedLBDoLoopEnd AddConflictedLBDoLoopEnd 0
      ReadINIStr $R7 "$PLUGINSDIR\XPIlist.ini" "x$R1" "Conflict$R5"
      StrCmp $R4 $R7 0 +4
        SendMessage $3 ${LB_ADDSTRING} 1 "STR:$R4"
        StrCpy $R6 "1"
        Goto AddConflictedLBDoLoopEnd
      IntOp $R5 $R5 - 1
      Goto AddConflictedLBDoLoop
    AddConflictedLBDoLoopEnd:
    StrCmp $R6 "0" 0 +2
    SendMessage $4 ${LB_ADDSTRING} 1 "STR:$R4"
    IntOp $R3 $R3 - 1
    Goto AddConflictLBDoLoop
  AddConflictLBDoLoopEnd:

  ; 
  EndOfRefreshDCLB:
FunctionEnd


; =====
; ThemeJAR ]w
; =====
Function ThemeJARSettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox PowerPack HS GDDﶵ" "жפJ JAR ɨüg"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "ThemeJARImport.ini"
  Pop $HWND ;HWND of dialog
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function ThemeJARFunction
  ReadINIStr $1 "$PLUGINSDIR\ThemeJARImport.ini" "Settings" "State"
  StrCmp $1 "12" AddThemeJARFunc ; U"sW"s
  StrCmp $1 "3" DelThemeJARFunc ; U"R"s
  StrCmp $1 "0" OutputName ; U"U@B"sANƼgJ

  ; UsWsAsW
  AddThemeJARFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARImport.ini" "Field 7" "State"
  ReadINIStr $R2 "$PLUGINSDIR\ThemeJARImport.ini" "Field 8" "State"
  ReadINIStr $R3 "$PLUGINSDIR\ThemeJARImport.ini" "Field 10" "State"
  ReadINIStr $R4 "$PLUGINSDIR\ThemeJARlist.ini" "x$R1" "Desc"
  ReadINIStr $R5 "$PLUGINSDIR\XPIlist.ini" "x$R1" "Desc"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJGW"
    Abort
    Goto EndOfJARFunction
  StrCmp $R2 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJG"
    Abort
    Goto EndOfJARFunction
  StrCmp $R3 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ɮ׸|"
    Abort
    Goto EndOfJARFunction
  IfFileExists $R3 +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ɮ׸|"
    Abort
    Goto EndOfJARFunction
  StrCmp $R4 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١C"
    Abort
    Goto EndOfJARFunction
  StrCmp $R5 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١AzwgbMW٤ϥΤFoӦW١C$\r$\n$\r$\nƵGGDDPMW٪WCgbP@ɮסA]iHϥάۦPW١C"
    Abort
    Goto EndOfJARFunction
  ; T{L~AJ
  ReadINIStr $R6 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  IntOP $R6 $R6 + 1
  WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count" $R6
  WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R6" "$R1"
  WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "x$R1" "Desc" "$R2"
  WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "x$R1" "FilePath" "$R3"
  ; NW٥[JkRC
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  ; MſJ
  GetDlgItem $0 $HWND 1206
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1207
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1209
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  Abort
  Goto EndOfJARFunction

  ; U"R"s
  DelThemeJARFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARImport.ini" "Field 2" "State"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܭnRﶵ"
    Abort
    Goto EndOfJARFunction
  ; iƧR
  ; MԲӸT
  DeleteINISec "$PLUGINSDIR\ThemeJARlist.ini" "x$R1"
  ; MW٬
  ReadINIStr $R2 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  IntOp $R2 $R2 + 0 ; jഫƦr
  IntOp $R3 0 + 1
  IntOp $R4 0 + 1
  DelNameDoLoop:
    IntCmp $R2 $R3 0 DelNameDoLoopEnd 0 ; if($R2==$R3||$R2>$R3){goto 0;}else{Goto DelNameDoLoopEnd;}
    ReadINIStr $R5 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R3"
    StrCmp $R1 $R5 +3 0 ; W٭Y@ˡAxs
      WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R4" $R5
      IntOp $R4 $R4 + 1
    IntOp $R3 $R3 + 1
    Goto DelNameDoLoop
  DelNameDoLoopEnd:
  DeleteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R2"
  IntOp $R6 $R2 - 1 ; ouƥ
  WriteINIStr "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count" "$R6"
  ; M椤W
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_FINDSTRINGEXACT} 1 "STR:$R1" $2
  SendMessage $0 ${LB_DELETESTRING} $2 1
  Abort
  Goto EndOfJARFunction

  ; U"U@B"sANƼgJ
  OutputName:
  ReadINIStr $R1 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "Count"
  StrCpy $R2 ""
  OutputNameDoLoop:
    IntCmp $R1 0 OutputNameDoLoopEnd OutputNameDoLoopEnd 0
    ReadINIStr $R3 "$PLUGINSDIR\ThemeJARlist.ini" "ThemeJAR" "File$R1"
    StrCpy $R2 "$R2|$R3"
    IntOP $R1 $R1 - 1
    Goto OutputNameDoLoop
  OutputNameDoLoopEnd:
  StrCpy $R2 $R2 "" 1
  WriteINIStr "$PLUGINSDIR\ThemeJARImport.ini" "Field 2" "ListItems" $R2

  ; 禡
  EndOfJARFunction:
FunctionEnd

; =====
; jM]w
; =====
Function SPSettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox PowerPack HS jMﶵ" "жפJ SRC ɡBϥɨüg"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "SPImport.ini"
  Pop $HWND ;HWND of dialog
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function SPFunction
  ReadINIStr $1 "$PLUGINSDIR\SPImport.ini" "Settings" "State"
  StrCmp $1 "12" AddSPFunc ; U"sW"s
  StrCmp $1 "3" DelSPFunc ; U"R"s
  StrCmp $1 "0" OutputName ; U"U@B"sANƼgJ̩ۨʳ]we

  ; UsWsAsW
  AddSPFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\SPImport.ini" "Field 7" "State"
  ReadINIStr $R2 "$PLUGINSDIR\SPImport.ini" "Field 8" "State"
  ReadINIStr $R3 "$PLUGINSDIR\SPImport.ini" "Field 10" "State"
  ReadINIStr $R4 "$PLUGINSDIR\SPImport.ini" "Field 13" "State"
  ReadINIStr $R5 "$PLUGINSDIR\SPlist.ini" "x$R1" "Desc"
  ReadINIStr $R6 "$PLUGINSDIR\XPIlist.ini" "x$R1" "Desc"
  ReadINIStr $R7 "$PLUGINSDIR\ThemeJARlist.ini" "x$R1" "Desc"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJjMW"
    Abort
    Goto EndOfSPFunction
  StrCmp $R2 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zSJjM"
    Abort
    Goto EndOfSPFunction
  StrCmp $R3 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~SRCɮ׸|"
    Abort
    Goto EndOfSPFunction
  IfFileExists $R3 +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~SRCɮ׸|"
    Abort
    Goto EndOfSPFunction
  StrCmp $R4 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ϥɮ׸|"
    Abort
    Goto EndOfSPFunction
  IfFileExists $R4 +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ϥɮ׸|"
    Abort
    Goto EndOfSPFunction
  StrCmp $R5 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١C"
    Abort
    Goto EndOfSPFunction
  StrCmp $R6 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١AzwgbMW٤ϥΤFoӦW١C$\r$\n$\r$\nƵGjMPMW٪WCgbP@ɮסA]iHϥάۦPW١C"
    Abort
    Goto EndOfSPFunction
  StrCmp $R7 "" +4 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zШϥΤFP˪W١AzwgbGW٤ϥΤFoӦW١C$\r$\n$\r$\nƵGjMPGDDWCgbP@ɮסA]iHϥάۦPW١C"
    Abort
    Goto EndOfSPFunction
  ; T{L~AJ
  ReadINIStr $R8 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  IntOP $R8 $R8 + 1
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "SP" "Count" $R8
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "SP" "File$R8" "$R1"
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "x$R1" "Desc" "$R2"
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "x$R1" "FileSRCPath" "$R3"
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "x$R1" "FileICONPath" "$R4"
  ; NW٥[JkRC
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_ADDSTRING} 1 "STR:$R1"
  ; MſJ
  GetDlgItem $0 $HWND 1206
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1207
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1209
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  GetDlgItem $0 $HWND 1213 ; 1200 + (13 - 1) + 1 ; (13-1)=Field Num - 1, 1="..."Button
  SendMessage $0 ${WM_SETTEXT} 1 "STR:"
  Abort
  Goto EndOfSPFunction

  ; U"R"s
  DelSPFunc:
  ; oJ
  ReadINIStr $R1 "$PLUGINSDIR\SPImport.ini" "Field 2" "State"
  ; ˬd
  StrCmp $R1 "" 0 +4
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "пܭnRﶵ"
    Abort
    Goto EndOfSPFunction
  ; iƧR
  ; MԲӸT
  DeleteINISec "$PLUGINSDIR\SPlist.ini" "x$R1"
  ; MW٬
  ReadINIStr $R2 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  IntOp $R2 $R2 + 0 ; jഫƦr
  IntOp $R3 0 + 1
  IntOp $R4 0 + 1
  DelNameDoLoop:
    IntCmp $R2 $R3 0 DelNameDoLoopEnd 0 ; if($R2==$R3||$R2>$R3){goto 0;}else{Goto DelNameDoLoopEnd;}
    ReadINIStr $R5 "$PLUGINSDIR\SPlist.ini" "SP" "File$R3"
    StrCmp $R1 $R5 +3 0 ; W٭Y@ˡAxs
      WriteINIStr "$PLUGINSDIR\SPlist.ini" "SP" "File$R4" $R5
      IntOp $R4 $R4 + 1
    IntOp $R3 $R3 + 1
    Goto DelNameDoLoop
  DelNameDoLoopEnd:
  DeleteINIStr "$PLUGINSDIR\SPlist.ini" "SP" "File$R2"
  IntOp $R6 $R2 - 1 ; ouƥ
  WriteINIStr "$PLUGINSDIR\SPlist.ini" "SP" "Count" "$R6"
  ; M椤W
  GetDlgItem $0 $HWND 1201
  SendMessage $0 ${LB_FINDSTRINGEXACT} 1 "STR:$R1" $2
  SendMessage $0 ${LB_DELETESTRING} $2 1
  Abort
  Goto EndOfSPFunction

  ; U"U@B"sANƼgJ
  OutputName:
  ReadINIStr $R1 "$PLUGINSDIR\SPlist.ini" "SP" "Count"
  StrCpy $R2 ""
  OutputNameDoLoop:
    IntCmp $R1 0 OutputNameDoLoopEnd OutputNameDoLoopEnd 0
    ReadINIStr $R3 "$PLUGINSDIR\SPlist.ini" "SP" "File$R1"
    StrCpy $R2 "$R2|$R3"
    IntOP $R1 $R1 - 1
    Goto OutputNameDoLoop
  OutputNameDoLoopEnd:
  StrCpy $R2 $R2 "" 1
  WriteINIStr "$PLUGINSDIR\SPImport.ini" "Field 2" "ListItems" $R2

  ; 禡
  EndOfSPFunction:
FunctionEnd

; =====
; ҳ]w
; =====
Function BookmarksSettingPage
  !insertmacro MUI_HEADER_TEXT "Firefox PowerPack HS ҿﶵ" "п bookmarks.html m"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "BookmarkImport.ini"
  Pop $HWND ;HWND of dialog

  GetDlgItem $0 $HWND 1203 ; w"ɮs"r
  EnableWindow $0 0

  ReadINIStr $BookmarksHTMLPath "$PLUGINSDIR\BookmarkImport.ini" "Field 4" "State" ; Ū
  IfFileExists $BookmarksHTMLPath +3 0 ; YɮצsbAhLw
    GetDlgItem $0 $HWNDPARENT 1 ; w"U@B"s
    EnableWindow $0 0

  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd

Function BookmarksCheck
  ReadINIStr $1 "$PLUGINSDIR\BookmarkImport.ini" "Settings" "State"
  StrCmp $1 "4" CheckField4 ; U"..."sAiˬd
  StrCmp $1 "0" EndOfBookmarksCheck ; U"U@B"sAL

  ; ˬd Firefox w˵{|
  CheckField4:
  ReadINIStr $BookmarksHTMLPath "$PLUGINSDIR\BookmarkImport.ini" "Field 4" "State"
  IfFileExists $BookmarksHTMLPath EnableNextButton 0
    MessageBOX MB_OK|MB_ICONEXCLAMATION|MB_TOPMOST|MB_SETFOREGROUND "zwF~ɮ׸|"
    GetDlgItem $0 $HWND 1203 ; X File Request Text Field
    SendMessage $0 ${WM_SETTEXT} 1 "STR:" ; M
    GetDlgItem $0 $HWNDPARENT 1 ; X"U@B"s
    EnableWindow $0 0 ; w"U@B"s
    Abort
    Goto EndOfBookmarksCheck

  ; Yɮצsb
  EnableNextButton:
  GetDlgItem $0 $HWNDPARENT 1 ; Ѱw"U@B"s
  EnableWindow $0 1
  Abort

  ; ˬd
  EndOfBookmarksCheck:
FunctionEnd

; =====
; w˵{lƨ禡
; =====
Function .onInit
  ; lƦw˵{ȦsƧ
  InitPluginsDir
  ;ExecShell "open" "$PLUGINSDIR" ; open only when developing

  ; M NSIS s񪺸Ƨ
  ReadREGStr $NSISDirPath HKLM "Software\NSIS" ""
  StrCmp $NSISDirPath "" 0 +5
    MessageBOX MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_SETFOREGROUND "z٥w NSIS AoOs@ Firefox PowerPack HS ҥݪnAzw˥C$\r$\n$\r$\nznsӺ$\"http://nsis.sf.net$\"ܡH" IDYES 0 IDNO +2
      ExecShell "open" "http://nsis.sf.net"
    Abort
    Goto EndOfNSISInit

  ; ٭쭶]w(IO.ini)
  File "/oname=$PLUGINSDIR\WelcomeLicense.ini" "IncludeFiles\WelcomeLicense.ini"
  File "/oname=$PLUGINSDIR\FxSettingIO.ini" "IncludeFiles\FxSettingIO.ini"
  File "/oname=$PLUGINSDIR\XPIImport.ini" "IncludeFiles\XPIImport.ini"
  File "/oname=$PLUGINSDIR\DependConfig.ini" "IncludeFiles\DependConfig.ini"
  File "/oname=$PLUGINSDIR\ThemeJARImport.ini" "IncludeFiles\ThemeJARImport.ini"
  File "/oname=$PLUGINSDIR\SPImport.ini" "IncludeFiles\SPImport.ini"
  File "/oname=$PLUGINSDIR\BookmarkImport.ini" "IncludeFiles\BookmarkImport.ini"

  ; {
  EndOfNSISInit:
FunctionEnd